"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _Alert = _interopRequireDefault(require("./Alert"));
var _AlertsContextProvider = require("./AlertsContextProvider");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _objectDestructuringEmpty(obj) { if (obj == null) throw new TypeError("Cannot destructure " + obj); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
var Alerts = function Alerts(_ref) {
  var args = _extends({}, (_objectDestructuringEmpty(_ref), _ref));
  var _useAlertsContext = (0, _AlertsContextProvider.useAlertsContext)(),
    alerts = _useAlertsContext.alerts;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "alerts-container"
  }, alerts.map(function (alert, key) {
    return /*#__PURE__*/_react["default"].createElement(_Alert["default"], {
      key: key,
      alert: alert
    });
  }));
};
var _default = exports["default"] = Alerts;