"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _sortable = require("@dnd-kit/sortable");
var _utilities = require("@dnd-kit/utilities");
var _react = _interopRequireDefault(require("react"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
var DnDItem = function DnDItem(_ref) {
  var templateItem = _ref.templateItem,
    item = _ref.item,
    index = _ref.index;
  var _useSortable = (0, _sortable.useSortable)({
      id: item.id
    }),
    attributes = _useSortable.attributes,
    listeners = _useSortable.listeners,
    setNodeRef = _useSortable.setNodeRef,
    transform = _useSortable.transform,
    transition = _useSortable.transition;
  var style = {
    transform: _utilities.CSS.Transform.toString(transform),
    transition: transition
  };
  return /*#__PURE__*/_react["default"].createElement("div", _extends({
    ref: setNodeRef,
    style: style
  }, listeners, attributes), templateItem(item, index));
};
var _default = exports["default"] = DnDItem;