"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useFormContext = exports["default"] = exports.DisplayErrorCtx = void 0;
var _react = _interopRequireWildcard(require("react"));
var _excluded = ["children", "formFields", "setFormFields", "onSubmit", "submitLabel", "cancelLabel", "disabled", "isLoading", "onCancel", "errorMessage", "isFormValid", "displaySubmitError", "hideValidateButton"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var DisplayErrorCtx = exports.DisplayErrorCtx = /*#__PURE__*/_react["default"].createContext(false);
var CustomForm = function CustomForm(_ref, ref) {
  var children = _ref.children,
    _ref$formFields = _ref.formFields,
    formFields = _ref$formFields === void 0 ? {} : _ref$formFields,
    _ref$setFormFields = _ref.setFormFields,
    setFormFields = _ref$setFormFields === void 0 ? function () {} : _ref$setFormFields,
    _ref$onSubmit = _ref.onSubmit,
    onSubmit = _ref$onSubmit === void 0 ? function () {} : _ref$onSubmit,
    _ref$submitLabel = _ref.submitLabel,
    submitLabel = _ref$submitLabel === void 0 ? 'Valider' : _ref$submitLabel,
    _ref$cancelLabel = _ref.cancelLabel,
    cancelLabel = _ref$cancelLabel === void 0 ? 'Annuler' : _ref$cancelLabel,
    _ref$disabled = _ref.disabled,
    disabled = _ref$disabled === void 0 ? false : _ref$disabled,
    _ref$isLoading = _ref.isLoading,
    isLoading = _ref$isLoading === void 0 ? false : _ref$isLoading,
    _ref$onCancel = _ref.onCancel,
    onCancel = _ref$onCancel === void 0 ? null : _ref$onCancel,
    _ref$errorMessage = _ref.errorMessage,
    errorMessage = _ref$errorMessage === void 0 ? null : _ref$errorMessage,
    _ref$isFormValid = _ref.isFormValid,
    isFormValid = _ref$isFormValid === void 0 ? true : _ref$isFormValid,
    _ref$displaySubmitErr = _ref.displaySubmitError,
    displaySubmitError = _ref$displaySubmitErr === void 0 ? false : _ref$displaySubmitErr,
    _ref$hideValidateButt = _ref.hideValidateButton,
    hideValidateButton = _ref$hideValidateButt === void 0 ? false : _ref$hideValidateButt,
    props = _objectWithoutProperties(_ref, _excluded);
  var _useState = (0, _react.useState)(false),
    _useState2 = _slicedToArray(_useState, 2),
    displayError = _useState2[0],
    setDisplayError = _useState2[1];
  var _useState3 = (0, _react.useState)(null),
    _useState4 = _slicedToArray(_useState3, 2),
    submitError = _useState4[0],
    setSubmitError = _useState4[1];
  var _useState5 = (0, _react.useState)(false),
    _useState6 = _slicedToArray(_useState5, 2),
    isLoadingSubmit = _useState6[0],
    setIsLoadingSubmit = _useState6[1];
  var context = (0, _react.useMemo)(function () {
    return {
      displayError: displayError,
      formFields: formFields,
      setFormFields: setFormFields,
      setFormField: function setFormField(fieldName, value) {
        return setFormFields(function (prev) {
          return _objectSpread(_objectSpread({}, prev), {}, _defineProperty({}, fieldName, value));
        });
      }
    };
  }, [displayError, formFields]);
  var submit = function submit(e) {
    e.preventDefault();
    !displayError && setDisplayError(true);
    if (isFormValid) {
      setIsLoadingSubmit(true);
      Promise.resolve(onSubmit(e))["catch"](function (e) {
        return setSubmitError(e.response.data), console.log(e.config.data);
      })["finally"](function () {
        return setIsLoadingSubmit(false);
      });
    }
  };
  return /*#__PURE__*/_react["default"].createElement(DisplayErrorCtx.Provider, {
    value: context
  }, /*#__PURE__*/_react["default"].createElement("form", _extends({
    onSubmit: submit
  }, props, {
    ref: ref
  }), children, displayError && !isFormValid && errorMessage != null && /*#__PURE__*/_react["default"].createElement("p", {
    className: "informations danger"
  }, errorMessage), submitError != null && /*#__PURE__*/_react["default"].createElement("p", {
    className: "informations"
  }, "Une erreur est survenue", ' ', displaySubmitError && /*#__PURE__*/_react["default"].createElement("span", null, ": ", submitError)), /*#__PURE__*/_react["default"].createElement("div", {
    className: "form-buttons-container"
  }, !hideValidateButton && /*#__PURE__*/_react["default"].createElement("button", {
    disabled: disabled || isLoading,
    className: "btn btn-primary flex line spaced-inline ".concat((disabled || isLoading) && 'disabled')
  }, /*#__PURE__*/_react["default"].createElement("span", null, submitLabel), (isLoading || isLoadingSubmit) && /*#__PURE__*/_react["default"].createElement("div", {
    className: "spinner-border spinner-border-sm",
    role: "status"
  })), onCancel != null && /*#__PURE__*/_react["default"].createElement("button", {
    className: "btn btn-secondary",
    type: "button",
    onClick: onCancel
  }, cancelLabel))));
};
var useFormContext = exports.useFormContext = function useFormContext() {
  return (0, _react.useContext)(DisplayErrorCtx);
};
var _default = exports["default"] = /*#__PURE__*/_react["default"].forwardRef(CustomForm);