"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactSelect = _interopRequireDefault(require("react-select"));
var _CustomForm = require("./CustomForm");
var _reactSelectStyle = require("./react-select-style");
var _excluded = ["options", "value", "onChange", "isValid", "noOptionMessage", "placeholder", "disabled", "multi", "fieldName", "setFormField"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var CustomFormFieldSelect = function CustomFormFieldSelect(_ref, ref) {
  var _ref$options = _ref.options,
    options = _ref$options === void 0 ? [] : _ref$options,
    value = _ref.value,
    onChange = _ref.onChange,
    _ref$isValid = _ref.isValid,
    isValid = _ref$isValid === void 0 ? true : _ref$isValid,
    _ref$noOptionMessage = _ref.noOptionMessage,
    noOptionMessage = _ref$noOptionMessage === void 0 ? 'Aucun résultat' : _ref$noOptionMessage,
    _ref$placeholder = _ref.placeholder,
    placeholder = _ref$placeholder === void 0 ? '' : _ref$placeholder,
    _ref$disabled = _ref.disabled,
    disabled = _ref$disabled === void 0 ? false : _ref$disabled,
    _ref$multi = _ref.multi,
    multi = _ref$multi === void 0 ? false : _ref$multi,
    _ref$fieldName = _ref.fieldName,
    fieldName = _ref$fieldName === void 0 ? '' : _ref$fieldName,
    _ref$setFormField = _ref.setFormField,
    setFormField = _ref$setFormField === void 0 ? function () {} : _ref$setFormField,
    props = _objectWithoutProperties(_ref, _excluded);
  var _useFormContext = (0, _CustomForm.useFormContext)(),
    displayError = _useFormContext.displayError;
  var allOptions = options.reduce(function (prev, current) {
    if (current.options != null) {
      return [].concat(_toConsumableArray(prev), _toConsumableArray(current.options));
    }
    return [].concat(_toConsumableArray(prev), [current]);
  }, []);
  var formattedValue = (0, _react.useMemo)(function () {
    var _allOptions$find;
    return !multi ? (_allOptions$find = allOptions.find(function (o) {
      return o.value === value;
    })) !== null && _allOptions$find !== void 0 ? _allOptions$find : '' : allOptions.filter(function (o) {
      return value.includes(o.value);
    });
  }, [value, allOptions]);
  var handleChangeSelect = function handleChangeSelect(obj) {
    if (fieldName != '' && onChange == null) setFormField(fieldName, multi ? obj.map(function (_ref2) {
      var value = _ref2.value;
      return value;
    }) : obj.value);else if (onChange != null) onChange(obj);
  };
  var style = (0, _react.useMemo)(function () {
    return getComputedStyle(document.body);
  }, []);
  return /*#__PURE__*/_react["default"].createElement(_reactSelect["default"], _extends({
    className: "react-select ".concat(!isValid && displayError ? 'is-invalid' : ''),
    value: formattedValue,
    onChange: handleChangeSelect,
    options: options,
    noOptionsMessage: function noOptionsMessage() {
      return noOptionMessage;
    },
    placeholder: placeholder,
    isDisabled: disabled,
    isMulti: multi
  }, (0, _reactSelectStyle.reactSelectStyle)(displayError, isValid), props));
};
var _default = exports["default"] = CustomFormFieldSelect;