"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var Step = function Step(_ref) {
  var step = _ref.step,
    index = _ref.index,
    currentStep = _ref.currentStep,
    isLastStep = _ref.isLastStep,
    _ref$pendingIcon = _ref.pendingIcon,
    pendingIcon = _ref$pendingIcon === void 0 ? 'alert' : _ref$pendingIcon;
  var isActif = currentStep === index;
  var icon = isActif ? 'pencil' : currentStep > index ? 'check' : pendingIcon;
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("span", {
    className: "step ".concat(isActif ? 'actif' : '', " ").concat(currentStep > index ? 'passed' : '')
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: "step-label"
  }, step), /*#__PURE__*/_react["default"].createElement("div", {
    className: "circle-container"
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: "circle"
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: "mdi mdi-".concat(icon, " mdi-36px")
  })))), !isLastStep && /*#__PURE__*/_react["default"].createElement("span", {
    key: "line-".concat(index),
    className: "line ".concat(currentStep > index ? 'passed' : '')
  }));
};
var _default = exports["default"] = Step;