"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useConfirm = exports["default"] = exports.ConfirmContext = void 0;
var _react = _interopRequireWildcard(require("react"));
var _CustomModal = _interopRequireDefault(require("./CustomModal"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
var Confirm = function Confirm() {
  var context = (0, _react.useContext)(ConfirmContext);
  return /*#__PURE__*/_react["default"].createElement(_CustomModal["default"], {
    title: context.title,
    content: context.content,
    cancelLabel: "Annuler",
    validateLabel: context.validateLabel,
    show: context.show,
    onValidate: context.callback,
    setShow: function setShow() {
      return context.setContext(_objectSpread(_objectSpread({}, context), {}, {
        show: false
      }));
    },
    hideCancel: context.hideCancel
  });
};
var ConfirmContext = exports.ConfirmContext = /*#__PURE__*/_react["default"].createContext({
  title: '',
  content: '',
  show: false,
  callback: function callback() {},
  setContext: null,
  hideCancel: false,
  validateLabel: 'Confirmer'
});
var useConfirm = exports.useConfirm = function useConfirm() {
  var confirmContext = (0, _react.useContext)(ConfirmContext);
  var confirm = function confirm(content, callback) {
    var title = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'Confirmation';
    var hideCancel = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
    var validateLabel = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 'Confirmer';
    return confirmContext.setContext({
      title: title,
      content: content,
      callback: callback,
      show: true,
      hideCancel: hideCancel,
      validateLabel: validateLabel
    });
  };
  return confirm;
};
var _default = exports["default"] = Confirm;