"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _Modal = _interopRequireDefault(require("react-bootstrap/Modal"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var CustomModal = function CustomModal(_ref) {
  var _ref$show = _ref.show,
    show = _ref$show === void 0 ? false : _ref$show,
    _ref$title = _ref.title,
    title = _ref$title === void 0 ? '' : _ref$title,
    _ref$content = _ref.content,
    content = _ref$content === void 0 ? '' : _ref$content,
    _ref$onValidate = _ref.onValidate,
    onValidate = _ref$onValidate === void 0 ? function () {} : _ref$onValidate,
    _ref$setShow = _ref.setShow,
    setShow = _ref$setShow === void 0 ? function () {} : _ref$setShow,
    _ref$validateLabel = _ref.validateLabel,
    validateLabel = _ref$validateLabel === void 0 ? 'Enregistrer' : _ref$validateLabel,
    _ref$cancelLabel = _ref.cancelLabel,
    cancelLabel = _ref$cancelLabel === void 0 ? 'Annuler' : _ref$cancelLabel,
    _ref$validateDisabled = _ref.validateDisabled,
    validateDisabled = _ref$validateDisabled === void 0 ? false : _ref$validateDisabled,
    _ref$hideCancel = _ref.hideCancel,
    hideCancel = _ref$hideCancel === void 0 ? false : _ref$hideCancel,
    _ref$width = _ref.width,
    width = _ref$width === void 0 ? '' : _ref$width,
    _ref$onCancel = _ref.onCancel,
    onCancel = _ref$onCancel === void 0 ? function () {} : _ref$onCancel;
  (0, _react.useEffect)(function () {}, []);
  var cancel = function cancel() {
    onCancel();
    setShow(false);
  };
  var click = function click() {
    cancel();
    onValidate();
  };
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Modal["default"], {
    show: show,
    tabIndex: "-1",
    dialogClassName: "".concat(width != '' ? "modal-".concat(width) : '')
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "modal-content"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "modal-header"
  }, /*#__PURE__*/_react["default"].createElement("h1", {
    className: "modal-title fs-5",
    id: "exampleModalLabel"
  }, title)), /*#__PURE__*/_react["default"].createElement("div", {
    className: "modal-body"
  }, content), /*#__PURE__*/_react["default"].createElement("div", {
    className: "modal-footer"
  }, !hideCancel && /*#__PURE__*/_react["default"].createElement("button", {
    type: "button",
    className: "btn btn-secondary",
    onClick: cancel
  }, cancelLabel), /*#__PURE__*/_react["default"].createElement("button", {
    type: "button",
    className: "btn btn-primary",
    onClick: click,
    disabled: validateDisabled
  }, validateLabel)))));
};
var _default = exports["default"] = CustomModal;