"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactPdf = require("react-pdf");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
_reactPdf.pdfjs.GlobalWorkerOptions.workerSrc = new URL('pdfjs-dist/build/pdf.worker.min.mjs', import.meta.url).toString();
var PDFView = function PDFView(_ref) {
  var file = _ref.file,
    width = _ref.width,
    _ref$displayLastPage = _ref.displayLastPage,
    displayLastPage = _ref$displayLastPage === void 0 ? false : _ref$displayLastPage;
  var _useState = (0, _react.useState)(null),
    _useState2 = _slicedToArray(_useState, 2),
    numPages = _useState2[0],
    setNumPages = _useState2[1];
  var _useState3 = (0, _react.useState)(1),
    _useState4 = _slicedToArray(_useState3, 2),
    pageNumber = _useState4[0],
    setPageNumber = _useState4[1];
  var _useState5 = (0, _react.useState)(null),
    _useState6 = _slicedToArray(_useState5, 2),
    fileURL = _useState6[0],
    setFileURL = _useState6[1];
  (0, _react.useEffect)(function () {
    if (file != null && file.type === 'application/pdf') {
      var objectURL = URL.createObjectURL(file);
      setFileURL(objectURL);
    } else if (typeof file === 'string') {
      setFileURL(file);
    }
  }, [file]);
  (0, _react.useEffect)(function () {
    if (numPages != null) {
      setPageNumber(displayLastPage ? numPages : 1);
    }
  }, [numPages, displayLastPage]);
  function onDocumentLoadSuccess(_ref2) {
    var numPages = _ref2.numPages;
    setNumPages(numPages);
  }
  var isFirstPage = (0, _react.useMemo)(function () {
    return pageNumber === 1;
  }, [pageNumber]);
  var isLastPage = (0, _react.useMemo)(function () {
    return pageNumber === numPages;
  }, [pageNumber, numPages]);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "pdf-view"
  }, fileURL != null && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "pdf-buttons spaced-inline"
  }, /*#__PURE__*/_react["default"].createElement("button", {
    className: "btn btn-outline-primary",
    onClick: function onClick() {
      return setPageNumber(pageNumber - 1);
    },
    disabled: isFirstPage,
    type: "button"
  }, "Page pr\xE9c\xE9dente"), /*#__PURE__*/_react["default"].createElement("button", {
    className: "btn btn-outline-primary",
    onClick: function onClick() {
      return setPageNumber(pageNumber + 1);
    },
    disabled: isLastPage,
    type: "button"
  }, "Page suivante")), /*#__PURE__*/_react["default"].createElement(_reactPdf.Document, {
    loading: /*#__PURE__*/_react["default"].createElement("p", {
      className: "informations "
    }, /*#__PURE__*/_react["default"].createElement("span", {
      className: "spinner-border"
    }, /*#__PURE__*/_react["default"].createElement("span", {
      className: "sr-only"
    }))),
    file: fileURL,
    onLoadSuccess: onDocumentLoadSuccess
  }, !isFirstPage && /*#__PURE__*/_react["default"].createElement(_reactPdf.Page, {
    className: "prev-page",
    pageNumber: pageNumber - 1,
    renderTextLayer: false,
    renderAnnotationLayer: false,
    width: width
  }), /*#__PURE__*/_react["default"].createElement(_reactPdf.Page, {
    pageNumber: pageNumber,
    renderTextLayer: false,
    renderAnnotationLayer: false,
    width: width
  }), !isLastPage && /*#__PURE__*/_react["default"].createElement(_reactPdf.Page, {
    className: "next-page",
    pageNumber: pageNumber + 1,
    renderTextLayer: false,
    renderAnnotationLayer: false,
    width: width
  }))));
};
var _default = exports["default"] = PDFView;