"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _Step = _interopRequireDefault(require("./Step"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var Steps = function Steps(_ref) {
  var _ref$steps = _ref.steps,
    steps = _ref$steps === void 0 ? [] : _ref$steps,
    _ref$currentStep = _ref.currentStep,
    currentStep = _ref$currentStep === void 0 ? 0 : _ref$currentStep,
    _ref$pendingIcon = _ref.pendingIcon,
    pendingIcon = _ref$pendingIcon === void 0 ? 'alert' : _ref$pendingIcon;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "steps"
  }, steps.map(function (step, index) {
    return /*#__PURE__*/_react["default"].createElement(_Step["default"], {
      key: index,
      step: step,
      index: index,
      currentStep: currentStep,
      isLastStep: index === steps.length - 1,
      pendingIcon: pendingIcon
    });
  }));
};
var _default = exports["default"] = Steps;