"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reactSelectStyle = void 0;
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
var reactSelectStyle = exports.reactSelectStyle = function reactSelectStyle(displayError, isValid) {
  return {
    theme: function theme(_theme) {
      var style = getComputedStyle(document.body);
      return _objectSpread(_objectSpread({}, _theme), {}, {
        borderRadius: '1rem',
        spacing: _objectSpread(_objectSpread({}, _theme.spacing), {}, {
          controlHeight: 50
        }),
        colors: _objectSpread(_objectSpread({}, _theme.colors), {}, {
          primary: style.getPropertyValue('--bs-primary'),
          secondary: style.getPropertyValue('--bs-secondary')
        })
      });
    },
    styles: {
      option: function option(styles, data) {
        var isFirst = data.options[0].value === data.value;
        var isLast = data.options[data.options.length - 1].value === data.value;
        if (isFirst) {
          styles.borderTopLeftRadius = '1rem';
          styles.borderTopRightRadius = '1rem';
        }
        if (isLast) {
          styles.borderBottomLeftRadius = '1rem';
          styles.borderBottomRightRadius = '1rem';
        }
        styles.minHeight = '2rem';
        return styles;
      },
      control: function control(styles, data) {
        var style = getComputedStyle(document.body);
        if (displayError && !isValid && !data.isFocused) {
          styles.border = "1px solid ".concat(style.getPropertyValue('--bs-orange'), " !important");
        }
        return styles;
      },
      multiValue: function multiValue(base) {
        return _objectSpread(_objectSpread({}, base), {}, {
          borderRadius: '0.25em'
        });
      }
    }
  };
};