"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = require("react");
var useUpdateEffect = function useUpdateEffect(effect, deps) {
  var isFirstMount = (0, _react.useRef)(true);
  (0, _react.useEffect)(function () {
    if (!isFirstMount.current) effect();else isFirstMount.current = false;
  }, deps);
};
var _default = exports["default"] = useUpdateEffect;